/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.RutaSecuenciaDAO;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.RutaSecuencia;
import com.rjconsultores.ventaboletos.service.RutaSecuenciaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("rutaSecuenciaService")
public class RutaSecuenciaServiceImpl implements RutaSecuenciaService {

    @Autowired
    private RutaSecuenciaDAO rutaSecuenciaDAO;

    public List<RutaSecuencia> obtenerTodos() {
        return rutaSecuenciaDAO.obtenerTodos();
    }

    public RutaSecuencia obtenerID(Integer id) {
        return rutaSecuenciaDAO.obtenerID(id);
    }

    @Transactional
    public RutaSecuencia suscribir(RutaSecuencia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return rutaSecuenciaDAO.suscribir(entidad);
    }

    @Transactional
    public RutaSecuencia actualizacion(RutaSecuencia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return rutaSecuenciaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(RutaSecuencia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        rutaSecuenciaDAO.actualizacion(entidad);
    }

    public List<RutaSecuencia> buscarSecuenciaOrdenado(Ruta ruta) {
        return rutaSecuenciaDAO.buscarSecuenciaOrdenado(ruta);
    }
    public int borrarSecuencias(Ruta ruta) {
    	return rutaSecuenciaDAO.borrarSecuencias(ruta);
    }

	@Override
	public List<Short> obtenerNumRutaSecuenciaPorCorridaOrigemDestino(EsquemaCorrida esquemaCorrida, Parada origem, Parada destino) {
		return rutaSecuenciaDAO.obtenerNumRutaSecuenciaPorCorridaOrigemDestino(esquemaCorrida, origem, destino);
	}

	@Override
	public List<Integer> obtenerNumRutaSecuenciaOcupadaPorCorridaAsiento(EsquemaCorrida esquemaCorrida, String asiento) {
		return rutaSecuenciaDAO.obtenerNumRutaSecuenciaOcupadaPorCorridaAsiento(esquemaCorrida, asiento);
	}
	
	@Override
	public List<Short> obtenerNumRutaSecuenciaPorCorridaOrigemDestinoId(EsquemaCorrida esquemaCorrida, Integer origem, Integer destino){
		return rutaSecuenciaDAO.obtenerNumRutaSecuenciaPorCorridaOrigemDestinoId(esquemaCorrida, origem, destino);
	}
}
